#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>
#include <string.h>
#include <unistd.h>
#include <sys/wait.h>


#define BUFFER_SIZE	1024
#define CMD_PORT	9900
#define BASE_LOAD	10000000

char *progName = "XLoad";

struct sockaddr_in svr, cli;
int s;
int s2;
int icli;
int fromlen;
int load = 0;
int activate = 0;

void *MakeLoad(void *);

main()
{
	char command[BUFFER_SIZE];
	char arg1[BUFFER_SIZE];
	char arg2[BUFFER_SIZE];
	pthread_t tId;


	if (pthread_create(&tId, NULL, MakeLoad, NULL)) {
		fprintf(stderr, "%s: Error in create thread for MakeLoad\n", progName);
		exit(0);
	}
	pthread_detach(tId); tId++;

	s = socket(AF_INET, SOCK_STREAM, 0);

	bzero(&svr, sizeof(svr));
	svr.sin_family = AF_INET;
	svr.sin_addr.s_addr = htonl(INADDR_ANY);
	svr.sin_port = htons(CMD_PORT);

	bind(s, (struct sockaddr *) &svr, sizeof(svr));
	listen(s, 4096);

	while (1) {
		printf("[%s]: Ready.\n", progName);
		s2 = accept(s, (struct sockaddr *) &cli, &icli);

		bzero(command, BUFFER_SIZE);
		recvfrom(s2, command, BUFFER_SIZE, MSG_WAITALL | MSG_NOSIGNAL, NULL, &fromlen);

		if (strstr(command, "load") != NULL) {
			close(s2);
			sscanf(command, "%s %s", arg1, arg2);
			printf("[%s] load change to %s received\n", progName, arg2);
			load = atoi(arg2);
		} else {
			printf("%s: Unknown command %s", progName, command);
			close(s2);
		}
	}
}


void *MakeLoad(void *arg)
{
	int i, j;
	while (1) {
		if (load > 1) {
			activate = 1;
			for (j = 0; j < load; j++) {
				for (i = 0; i < BASE_LOAD; i++) {
					;
				}
				if (load <= 1)
					break;
			}
		} else {
			if (activate != 0) {
				activate = 0;
				printf("[Load] Load deactivated\n"); fflush(stdout);
			}
		}
		sleep(1);
	}
}

